



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Codeforces VK CUP 2015 D. Closest Equals(线段树+扫描线)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Codeforces VK CUP 2015 D. Closest Equals(线段树+扫描线)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 15:29:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接:http://codeforces.com/contest/522/problem/D</p>
<p>题目大意: &nbsp;给你一个长度为n的序列,然后有m次查询,每次查询输入一个区间[li,lj],对于每一个查询,输出在这个区间内的两个相等的数的最短距离,如果没有相等的则输出-1.</p>
<p>线段树+扫描线,线段树维护的值是区间的最小值,从后往前扫,然后每次要做的事有两个:</p>
<p>1.判断当前这个位置 i 的数刚刚是不是出现过,假设刚刚出现的位置是 l ,如果出现过,则在线段树中把l这个位置的值更新为 l - i,同时更新包含这个点的区间的最小值.</p>
<p>2.判断有没有以当前这个位置为左端点的查询区间,如果有,就在线段树中查找这个区间里面的最小值.</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;iostream&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;map&gt;<br />
 #include&lt;list&gt;<br />
 using namespace std;<br />
 const int maxn = ,INF = 0x7fffff;<br />
 map&lt;int,int&gt; mp;

 int n,m,A[maxn];<br />
 struct node<br />
 {<br />
     int d,l,r;<br />
 }tree[*maxn];<br />
 struct Node<br />
 {<br />
     int flag,ans;<br />
     int l,r;<br />
 }Q[maxn];<br />
 bool cmp(Node a,Node b)<br />
 {<br />
     return a.l &gt;= b.l;<br />
 }<br />
 void maketree(node *tree,int p)<br />
 {<br />
     if(tree[p].l == tree[p].r)<br />
     {<br />
         tree[p].d = INF;<br />
         return ;<br />
     }<br />
     int mid = (tree[p].l + tree[p].r) / ;<br />
     tree[*p].l = tree[p].l;<br />
     tree[*p].r = mid;<br />
     tree[*p+].l = mid + ;<br />
     tree[*p+].r = tree[p].r;<br />
     tree[*p].d = tree[*p+].d = INF;<br />
     maketree(tree,*p);<br />
     maketree(tree,*p+);<br />
 }<br />
 void update(node *tree,int p,int loc,int d)<br />
 {<br />
     if(tree[p].l == tree[p].r)<br />
     {<br />
         tree[p].d = min(tree[p].d,d);<br />
         return ;<br />
     }<br />
     int mid = (tree[p].l + tree[p].r) / ;<br />
     if(loc &lt;= mid)<br />
         update(tree,*p,loc,d);<br />
     else update(tree,*p+,loc,d);<br />
     tree[p].d  = min(tree[p].d,d);<br />
 }<br />
 int data_sear;<br />
 void search(node *tree,int p,int l,int r)<br />
 {<br />
     if(tree[p].l == l &amp;&amp; tree[p].r == r)<br />
     {<br />
         data_sear = min(data_sear,tree[p].d);<br />
         return ;<br />
     }<br />
     int mid = (tree[p].l + tree[p].r) / ;<br />
     if(r &lt;= mid) search(tree,*p,l,r);<br />
     else if(l &lt;= mid &amp;&amp; r &gt; mid)<br />
     {<br />
         search(tree,*p,l,mid);<br />
         search(tree,*p+,mid+,r);<br />
     }<br />
     else if(l &gt; mid) search(tree,*p+,l,r);<br />
 }

 bool cmp2(Node a,Node b)<br />
 {<br />
     return a.flag &lt; b.flag;<br />
 }<br />
 int main()<br />
 {<br />
     while(scanf("%d%d",&amp;n,&amp;m)!=EOF)<br />
     {<br />
         for(int i = ;i &lt;= n;++i)<br />
             scanf("%d",&amp;A[i]);<br />
         for(int i = ;i &lt; m;++i)<br />
         {<br />
             scanf("%d%d",&amp;Q[i].l,&amp;Q[i].r);<br />
             Q[i].flag = i;<br />
             Q[i].ans = INF;<br />
         }<br />
         sort(Q,Q+m,cmp);     //按照左端点排好序,方便下面二分查找<br />
         tree[].l = ;<br />
         tree[].r = n;<br />
         tree[].d = INF;<br />
         maketree(tree,);   //构建好线段树<br />
         mp.clear();<br />
         int f = ;   //指向当前的查询<br />
         for(int i = n;i &gt;= ;--i)<br />
         {<br />
             if(mp[A[i]] != )<br />
             update(tree,,mp[A[i]],mp[A[i]]-i);   //更新线段树<br />
             mp[A[i]] = i;<br />
             while(f &lt; m &amp;&amp; Q[f].l == i)<br />
             {<br />
                 data_sear = INF;<br />
                 search(tree,,Q[f].l,Q[f].r);   //查询这个区间内的最小值<br />
                 Q[f].ans = (data_sear &lt;= n? data_sear:-);<br />
                 f++;<br />
             }<br />
         }<br />
         sort(Q,Q+m,cmp2);<br />
         for(int i = ;i &lt; m;++i)<br />
             printf("%d\n",Q[i].ans);<br />
     }<br />
     return ;<br />
 }</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2w14xq.html">eclipse连接多个git仓库方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93gyzn8.html">windows phone Datepicker Timepicker</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ernmmq.html">腾讯用过的插件jQuery twentytwenty 效果对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96r0gn9.html">CSS的相对定位和就对定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx05mvq.html">prototype linkage can reduce object initialization time and memory consumption</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3rjw9.html">对&period;Net WebSocket 和Socket的原理的思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydzj6jq.html">sudo nopasswd</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj0o4y9.html">linux学习笔记之文件结构和函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11pp1q.html">Centos 7 学习加入用户</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mee3kpq.html">&lbrack;Android&rsqb;BaseExpandableListAdapter实现可折叠列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpn4g59.html">创建 github 仓库</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ygg68.html">Java string和各种格式互转 string转int int转string</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zwj659.html">CTF---Web入门第五题 貌似有点难</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rmy149.html">Linux服务器部署javaweb项目，从环境配置，到最终系统运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvn3nj8.html">【原创】三招搞死你的IE11，可重现代码下载（IE Crash keyframes iframe）！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1lx149.html">&lbrack;js&rsqb;浏览器同源策略&lpar;same-origin policy&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvp6gz8.html">halcon区域运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy3dyjq.html">Java 8 并发性基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0prgq.html">【JAVA】枚举</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ppwm08.html">Orcale分析函数OVER&lpar;PARTITION BY&period;&period;&period; ORDER BY&period;&period;&period;&rpar;的讲解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q7e12e9.html">BZOJ1002&lbrack;FJOI2007&rsqb;轮状病毒</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnnegxq.html">android第一行代码－1&period;项目结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyvjgdq.html">visual studio 2015中的webapi生成helpPage，页面不显示方法说明问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql13x69.html">配置文件类 Properties</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8emg4e9.html">JAVA中int、String的类型转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o4edxq.html">C&num;扩展方法知多少</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zkwn38.html">微信快速开发框架（九）-- V3&period;0发布，代码已更新至Github 新增微店功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93pzzg8.html">如何修改Total Commander配件文件的位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2kpxvq.html">C 语言学习：班级同学的博客地址列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/39026ymq.html">【Python】&lbrack;进程和线程&rsqb;多进程，多线程，ThreadLocal，进程VS&period;线程，分布式进程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
